#include "AfterImageP.h"

int AfterImages_GetNumber(AfterImages after_images)
{
  return (after_images->number);
}

XArc * AfterImages_GetArcs(AfterImages after_images)
{
  return (after_images->arcs);
}

GCObj AfterImages_GetGCObj(AfterImages after_images)
{
  return ((GCObj)ObjListData_GetObj(after_images->gc));
}

GC AfterImages_GetGC(AfterImages after_images)
{
  return (GCObj_GetGC(AfterImages_GetGCObj(after_images)));
}

AfterImages AfterImages_Create(int r, int number, double * x, double * y,
			       int x_min, int y_min, int x_max, int y_max,
			       ObjList gc_list)
{
  AfterImages after_images;
  int i, n;

  after_images = (AfterImages)malloc(sizeof(_AfterImages));

  after_images->arcs = (XArc *)malloc(sizeof(XArc) * number);
  if (after_images->arcs == NULL)
    Error("AfterImages_Create", "Cannot allocate memory");

  n = 0;
  for (i = 0; i < number; i++) {

    if ((x[i] < x_min) || (x[i] > x_max) || (y[i] > y_max)) {
      continue;
    }

    after_images->arcs[n].x = x[i] - r;
    after_images->arcs[n].y = y[i] - r;
    after_images->arcs[n].width  = r * 2 + 1;
    after_images->arcs[n].height = r * 2 + 1;
    after_images->arcs[n].angle1 = 0;
    after_images->arcs[n].angle2 = 360*64;
    n++;
  }
  after_images->number = n;
  after_images->gc_list = gc_list;
  after_images->gc = ObjList_GetStart(after_images->gc_list);

  return (after_images);
}

AfterImages AfterImages_Destroy(AfterImages after_images)
{
  if (!after_images) return (NULL);

  if (after_images->arcs) free(after_images->arcs);

  free(after_images);

  return (NULL);
}

int AfterImages_IsEnd(AfterImages after_images)
{
  if (after_images->gc == NULL) return (1);
  if (ObjList_IsEndEdge(after_images->gc_list, after_images->gc))
    return (1);
  return (0);
}

int AfterImages_MoveNext(AfterImages after_images)
{
  if (after_images->gc == NULL) return (1);
  after_images->gc = ObjListData_GetNext(after_images->gc);

  return (AfterImages_IsEnd(after_images));
}

/* End of File */
