#include "RGBColorP.h"

/*===========================================================================*/
/* ǻѤؿ                                                        */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* 16ʢ10ʤؤѴ                                                        */
/*---------------------------------------------------------------------------*/

static int HexToDec(char c)
{
  switch (c) {
  case '0' : return (0);
  case '1' : return (1);
  case '2' : return (2);
  case '3' : return (3);
  case '4' : return (4);
  case '5' : return (5);
  case '6' : return (6);
  case '7' : return (7);
  case '8' : return (8);
  case '9' : return (9);
  case 'a' : case 'A' : return (10);
  case 'b' : case 'B' : return (11);
  case 'c' : case 'C' : return (12);
  case 'd' : case 'D' : return (13);
  case 'e' : case 'E' : return (14);
  case 'f' : case 'F' : return (15);
  }
  return (-1);
}

/*---------------------------------------------------------------------------*/
/* ñɤ߹                                                            */
/*---------------------------------------------------------------------------*/

static char * GetWord(Stream stream)
{
  char * word;
  word = Stream_GetWord(stream, NULL, 0,
			"",     /* ʸڤʬ */
			" \t",  /* ʸǤڤʬ */
			"", /* ȹԤƬʸ '#' ʤ */
			"\n",   /* ʸ '\n' ʤ */
			"", /* ʸ '\"' ʤ */
			"",     /* ʸƬɤߤȤФʸ */
			""      /* ʸɤߤȤФʸ */
			);
  return (word);
}

/*===========================================================================*/
/* RGBColor Ϣ                                                             */
/*===========================================================================*/

int RGBColor_GetBrightness(RGBColor rgb)
{
  int br;
  /*
  return ((rgb->red + rgb->green + rgb->blue) * 100 / (255 * 3));
  */

  br = rgb->red > rgb->green ? rgb->red : rgb->green;
  br = br > rgb->blue ? br : rgb->blue;

  return (br * 100 / 255);
}

RGBColor RGBColor_Create(unsigned char red,
			 unsigned char green,
			 unsigned char blue)
{
  RGBColor rgb;

  rgb = (RGBColor)malloc(sizeof(_RGBColor));

#if 0 /* unsigned char (0255) ʤΤǡɬ̵ */
  if (red   < 0) red   = 0; else if (red   > 255) red   = 255;
  if (green < 0) green = 0; else if (green > 255) green = 255;
  if (blue  < 0) blue  = 0; else if (blue  > 255) blue  = 255;
#endif

  rgb->red   = red;
  rgb->green = green;
  rgb->blue  = blue;

  return (rgb);
}

RGBColor RGBColor_Destroy(RGBColor rgb)
{
  if (!rgb) return (NULL);

  free(rgb);

  return (NULL);
}

/*---------------------------------------------------------------------------*/
/* "#f0f0f0" Τ褦ʸ󤫤RGBͤФ                               */
/*---------------------------------------------------------------------------*/

RGBColor RGBColor_CreateFromCharacters(char * string)
{
  unsigned char r, g, b;
  RGBColor rgb;

  r = g = b = 0;

  if (!string) {
    r = g = b = 0;
  } else {
    if (*string == '#') string++;

    r = HexToDec(string[0]) * 16 + HexToDec(string[1]);
    g = HexToDec(string[2]) * 16 + HexToDec(string[3]);
    b = HexToDec(string[4]) * 16 + HexToDec(string[5]);
  }

  rgb = RGBColor_Create(r, g, b);

  return (rgb);
}

/*---------------------------------------------------------------------------*/
/* RGBColor  RGBColor 롥                                           */
/*---------------------------------------------------------------------------*/

RGBColor RGBColor_CreateFromRGBColor(RGBColor rgb_color)
{
  return (RGBColor_Create(rgb_color->red, rgb_color->green, rgb_color->blue));
}

/*---------------------------------------------------------------------------*/
/* rgb1  rgb2 Ϳ줿ֿ׻                             */
/* per ǥѡơͿ롥                                            */
/* 0% ΤȤrgb1ˤʤ롥100%ΤȤrgb2 ˤʤ                            */
/*---------------------------------------------------------------------------*/

static RGBColor RGBColor_CreateMiddleColorFromRGB(unsigned char r1,
						  unsigned char g1,
						  unsigned char b1,
						  unsigned char r2,
						  unsigned char g2,
						  unsigned char b2,
						  int per)
{
  int r, g, b;

  if ((per < 0) || (per > 100)) return (NULL);

  r = r1 + (int)((double)(r2 - r1) * per / 100.0 + 0.5);
  g = g1 + (int)((double)(g2 - g1) * per / 100.0 + 0.5);
  b = b1 + (int)((double)(b2 - b1) * per / 100.0 + 0.5);

  return (RGBColor_Create(r, g, b));
}

/*---------------------------------------------------------------------------*/
/* rgb1  rgb2 Ϳ줿ֿ׻                             */
/* per ǥѡơͿ롥                                            */
/* 0% ΤȤrgb1ˤʤ롥100%ΤȤrgb2 ˤʤ                            */
/*---------------------------------------------------------------------------*/

RGBColor RGBColor_CreateMiddleColor(RGBColor rgb1, RGBColor rgb2, int per)
{
  unsigned char r1, g1, b1;
  unsigned char r2, g2, b2;

  if (rgb1) {
    r1 = rgb1->red;
    g1 = rgb1->green;
    b1 = rgb1->blue;
  } else {
    r1 = g1 = b1 = 0;
  }

  if (rgb2) {
    r2 = rgb2->red;
    g2 = rgb2->green;
    b2 = rgb2->blue;
  } else {
    r2 = g2 = b2 = 0;
  }

  return (RGBColor_CreateMiddleColorFromRGB(r1, g1, b1, r2, g2, b2, per));
}

/*---------------------------------------------------------------------------*/
/* rgb ȹֿ׻롥per ǥѡơͿ롥*/
/* 0% ΤȤrgbˤʤ롥100%ΤȤˤʤ */
/*---------------------------------------------------------------------------*/

RGBColor RGBColor_CreateMiddleColorToBlack(RGBColor rgb, int per)
{
  return (RGBColor_CreateMiddleColorFromRGB(rgb->red, rgb->green, rgb->blue,
					    0x0, 0x0, 0x0, per));
}

/*---------------------------------------------------------------------------*/
/* rgb ֿ׻롥per ǥѡơͿ롥*/
/* 0% ΤȤrgbˤʤ롥100%ΤȤˤʤ */
/*---------------------------------------------------------------------------*/

RGBColor RGBColor_CreateMiddleColorToWhite(RGBColor rgb, int per)
{
  return (RGBColor_CreateMiddleColorFromRGB(rgb->red, rgb->green, rgb->blue,
					    0xff, 0xff, 0xff, per));
}

unsigned long int RGBColor_GetColor(Disp disp, RGBColor rgb)
{
  unsigned long int c;
  char color_name[10];
#if 0
  c = (unsigned long int)(rgb->red  ) * 256
    + (unsigned long int)(rgb->green) * 256 * 256
    + (unsigned long int)(rgb->blue );
#else

  sprintf(color_name, "#%02x%02x%02x",
	  (int)(rgb->red),
	  (int)(rgb->green),
	  (int)(rgb->blue));

  c = Disp_GetPixel(disp, color_name);

#endif

  return (c);
}

/*===========================================================================*/
/* RGBColorChange Ϣ                                                       */
/*===========================================================================*/

static RGBColorChange RGBColorChange_CreateFromRGB(unsigned char r1,
						   unsigned char g1,
						   unsigned char b1,
						   unsigned char r2,
						   unsigned char g2,
						   unsigned char b2,
						   int length)
{
  RGBColorChange change;

  change = (RGBColorChange)malloc(sizeof(_RGBColorChange));

  change->start_rgb_color = RGBColor_Create(r1, g1, b1);
  change->end_rgb_color   = RGBColor_Create(r2, g2, b2);
  change->length = length;

  return (change);
}

RGBColorChange RGBColorChange_Create(RGBColor rgb1, RGBColor rgb2, int length)
{
  return (RGBColorChange_CreateFromRGB(rgb1->red, rgb1->green, rgb1->blue,
				       rgb2->red, rgb2->green, rgb2->blue,
				       length));
}

RGBColorChange RGBColorChange_Destroy(RGBColorChange change)
{
  RGBColor_Destroy(change->start_rgb_color);
  RGBColor_Destroy(change->end_rgb_color);
  free(change);
  return (NULL);
}

RGBColorChange RGBColorChange_CreateFromCharacters(char * str1, char * str2,
						   int length)
{
  RGBColor rgb_color1;
  RGBColor rgb_color2;
  RGBColorChange change;

  rgb_color1 = RGBColor_CreateFromCharacters(str1);
  rgb_color2 = RGBColor_CreateFromCharacters(str2);

  change = RGBColorChange_Create(rgb_color1, rgb_color2, length);

  RGBColor_Destroy(rgb_color1);
  RGBColor_Destroy(rgb_color2);

  return (change);
}

/*===========================================================================*/
/* RGBColorChange ΥꥹȴϢ                                               */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ꥹȤ椫顤counter бֿ׻RGBColor ֤       */
/*---------------------------------------------------------------------------*/

RGBColor RGBColorChangeList_GetRGBColor(ObjList list, int counter)
{
  ObjListData current;
  RGBColorChange change;
  RGBColor rgb_color = NULL;

  for (current = ObjList_GetStart(list);
       !ObjList_IsEndEdge(list, current);
       current = ObjListData_GetNext(current)) {

    change = (RGBColorChange)ObjListData_GetObj(current);

    if (counter <= change->length) {
      rgb_color =
	RGBColor_CreateMiddleColor(change->start_rgb_color,
				   change->end_rgb_color,
				   (int)(counter * 100
					 / change->length + 0.5));
      return (rgb_color);
    } else {
      counter -= change->length;
    }
  }

  return (NULL);
}

/*---------------------------------------------------------------------------*/
/* ǡʸ󤫤 RGBColorChange ΥꥹȤ֤                  */
/* ǡʸΥեޥåȤϰʲΤȤꡥ                                */
/* "[ȥ顼2] [ɥ顼2] [Ĺ1] [ȥ顼2] ...\0"       */
/* ) "#ffffff #f0f0f0 10 #f0f0f0 #a0a0a0 20 #a0a0a0 #000000 10\0"          */
/*---------------------------------------------------------------------------*/

ObjList RGBColorChangeList_CreateFromCharacters(char * data)
{
  Stream stream;
  char * start;
  char * end;
  char * len;
  int length;
  ObjList list;
  RGBColorChange change;

  list = ObjList_Create();

  if (!data) return (list);

  stream = Stream_CreateFromCharacters(data);

  while ((start = GetWord(stream)) != NULL) {
    end   = GetWord(stream);
    len   = GetWord(stream);
    if (len) length = atoi(len);
    else length = 1; 

    change = RGBColorChange_CreateFromCharacters(start, end, length);

    ObjList_InsertObjToEnd(list, change,
			   (ObjDestructor)RGBColorChange_Destroy);

    if (start)  free(start);
    if (end)    free(end);
    if (len)    free(len);
  }

  Stream_Destroy(stream);

  return (list);
}

/*****************************************************************************/
/* End of File                                                               */
/*****************************************************************************/
